Index: /pjproject/trunk/doc/pjsip-book/Makefile
===================================================================
--- /pjproject/trunk/doc/pjsip-book/Makefile	(revision 4771)
+++ /pjproject/trunk/doc/pjsip-book/Makefile	(revision 4772)
@@ -45,4 +45,14 @@
 	-rm -rf xml
 	-rm -rf html
+
+install:
+	@if test -z "$(WWWDIR)" ; then \
+	  echo WWWDIR is not set; \
+	else \
+	  echo Copying html dir to $(WWWDIR)/docs/book-latest/..; \
+	  cp -a -f _build/html $(WWWDIR)/docs/book-latest/; \
+	  echo Copying PJSUA2Doc.pdf to $(WWWDIR)/docs/book-latest/..; \
+	  cp -f _build/latex/PJSUA2Doc.pdf $(WWWDIR)/docs/book-latest/; \
+	fi
 
 xml:	Doxyfile ../../pjsip/include/pjsua2
Index: /pjproject/trunk/doc/pjsip-book/consider.rst
===================================================================
--- /pjproject/trunk/doc/pjsip-book/consider.rst	(revision 4771)
+++ /pjproject/trunk/doc/pjsip-book/consider.rst	(revision 4772)
@@ -1,3 +1,2 @@
-
 
 Development Guidelines and Considerations
@@ -16,6 +15,7 @@
 Development
 -------------
+* **Essential:** Follow the `Getting Started <http://trac.pjsip.org/repos/wiki/Getting-Started>`_ instructions to build PJSIP for your platform.
 * **Essential:** Interactive debugging capability is essential during development
-* Start with default settings in `<pj/config_site_sample.h>`.
+* Start with default settings in `<pj/config_site_sample.h>`. The default settings should be good to get you started. You can always optimize later after things are running okay.
 
 Coding Style
@@ -73,5 +73,5 @@
 All features except video are expected to work (video is coming soon!). Considerations for Android:
 
-#. You can only use pjsua2 Java binding for this target.
+#. You can only use PJSUA2 Java binding for this target.
 #. It has been reported that Android audio device is not so good in general, so some audio tuning may be needed. Echo cancellation also needs to be checked.
 #. This is also a new platform for us. 
@@ -104,5 +104,5 @@
 Windows Phone 8
 ---------------
-Windows Phone 8 (WP8) support is being added to PJSIP version 2.2 and is still under development. Specific considerations for this platform are:
+Windows Phone 8 (WP8) support is being added and is still under development on `projects/winphone` branch. Specific considerations for this platform are:
 
 #. WP8 governs specific interaction with WP8 GUI and framework that needs to be followed by application in order to make VoIP call work seamlessly on the device. Some lightweight process will be created by WP8 framework in order for background call to work and PJSIP needs to put its background processing in this process' context. Currently this feature is under development.
@@ -156,5 +156,5 @@
 
 
-pjsua2 C++ API
+PJSUA2 C++ API
 --------------
 pjsua2 is a new, objected oriented, C++ API created on top of PJSUA-LIB. The API is different than PJSUA-LIB, but it should be even easier to use and it should have better documentation too (such as this book). The pjsua2 API removes most cruxes typically associated with PJSIP, such as the pool and pj_str_t, and add new features such as object persistence so you can save your configs to a file, for example. All data structures are rewritten for more clarity. 
@@ -170,14 +170,15 @@
 
 
-Some considerations on pjsua2 C++ API are:
+Some considerations on PJSUA2 C++ API are:
+
 #. Instead of returning error, the API uses exception for error reporting
-#. pjsua2 uses standard C++ library
+#. It uses standard C++ library (STL)
 #. The performance penalty due to the API abstraction should be negligible on typical modern device
 
 
 
-pjsua2 API for Java, Python, and Others
+PJSUA2 API for Java, Python, and Others
 ---------------------------------------
-The pjsua2 API is also available for non-native code via SWIG binding. Configurations for Java and Python are provided with the distribution. Thanks to SWIG, other language bindings may be generated relatively easily.
+The PJSUA2 API is also available for non-native code via SWIG binding. Configurations for Java and Python are provided with the distribution. Thanks to SWIG, other language bindings may be generated relatively easily.
  
 The pjsua2 API for non-native code is effectively the same as pjsua2 C++ API. However, unlike C++, you cannot access PJSUA-LIB and the underlying C libraries from the scripting language, hence you are limited to what pjsua2 provides.
@@ -193,5 +194,5 @@
 NAT Issues
 ----------
-
+TBD.
 
 TCP Requirement
@@ -205,10 +206,10 @@
 Latency
 -------
-
+TBD.
 
 Echo Cancellation
 -----------------
-
-
-
-
+TBD.
+
+
+
Index: /pjproject/trunk/doc/pjsip-book/intro.rst
===================================================================
--- /pjproject/trunk/doc/pjsip-book/intro.rst	(revision 4771)
+++ /pjproject/trunk/doc/pjsip-book/intro.rst	(revision 4772)
@@ -4,15 +4,14 @@
 This documentation is intended for developers looking to develop Session Initiation Protocol (SIP) based client application. Some knowledge on SIP is definitely required, and of course some programming experience. Prior knowledge of PJSUA C API is not needed, although it will probably help.
 
-PJSIP libraries provide multi-level APIs to do SIP calls, presence, and instant messaging, as well as handling media and NAT traversal. Knowledge of SIP protocol details (such as the grammar, transaction, dialog, and whatnot) are not required (but it will help a lot!), however you should know how SIP works in general and particularly how to configure SIP clients to, e.g. register to a SIP provider, specify SIP URI to make call to, and so on, to use the module.
+PJSIP libraries provide multi-level APIs to do SIP calls, presence, and instant messaging, as well as handling media and NAT traversal. PJSUA2 API is the highest API from PJSIP, on top of PJSUA-LIB API. PJSUA-LIB API itself is a library that unifies SIP, audio/video media, NAT traversal, and client media application best practices into a high level, integrated, and easy to use API. The next chapter will guide you on selecting which API level to use depending on your requirements.
+
+This documentation can be `viewed online <http://www.pjsip.org/docs/book-latest/html/index.html>`_, or alternatively you can `download the PDF format <http://www.pjsip.org/docs/book-latest/PJSUA2Doc.pdf>`_ for offline viewing.
 
 Getting Started with PJSIP
 ==============================
-Check `PJSIP's Features List`_ to make sure that it has the features that you require.
+Check `PJSIP Datasheet <http://trac.pjsip.org/repos/wiki/PJSIP-Datasheet>`_ to make sure that it has the features that you require.
 
-.. _`PJSIP's Features List`: http://trac.pjsip.org/repos/wiki/PJSIP-Datasheet
+To start using PJSIP, the `Getting Started Guide <http://trac.pjsip.org/repos/wiki/Getting-Started>`_ contains instructions to acquire and build PJSIP on various platforms that we support.
 
-To start using PJSIP, the `Getting Started Guide`_ contains instructions to acquire and build PJSIP on various platforms that we support.
-
-.. _`Getting Started Guide`: http://trac.pjsip.org/repos/wiki/Getting-Started 
 
 PJSIP Info and Documentation
@@ -20,11 +19,7 @@
 To get other relevant info and documentations about PJSIP, you can visit:
 
-- `PJSIP General Wiki`_
-- `PJSIP FAQ`_
-- `PJSIP Reference Manual`_ - please see Reference Manual section
-
-.. _`PJSIP General Wiki`: http://trac.pjsip.org/repos/wiki
-.. _`PJSIP FAQ`: http://trac.pjsip.org/repos/wiki/FAQ
-.. _`PJSIP Reference Manual`: http://trac.pjsip.org/repos/wiki
+- `PJSIP General Wiki <http://trac.pjsip.org/repos/wiki>`_ is the home for all documentation
+- `PJSIP FAQ <http://trac.pjsip.org/repos/wiki/FAQ>`_
+- `PJSIP Reference Manual <http://trac.pjsip.org/repos/wiki>`_ - please see Reference Manual section
 
 
Index: /pjproject/trunk/doc/pjsip-book/intro_pjsua2.rst
===================================================================
--- /pjproject/trunk/doc/pjsip-book/intro_pjsua2.rst	(revision 4771)
+++ /pjproject/trunk/doc/pjsip-book/intro_pjsua2.rst	(revision 4772)
@@ -51,4 +51,7 @@
 ----------
 For platforms that require polling, the PJSUA2 module provides its own worker thread to poll PJSIP, so it is not necessary to instantiate own your polling thread. Having said that the application should be prepared to have the callbacks called by different thread than the main thread. The PJSUA2 module itself is thread safe.
+
+Often though, especially if you use PJSUA2 with high level languages such as Python, it is required to disable PJSUA2 internal worker threads by setting EpConfig.uaConfig.threadCnt to 0, because the high level environment doesn't like to be called by external thread (such as PJSIP's worker thread).
+
 
 Problems with Garbage Collection
@@ -97,5 +100,5 @@
 Building PJSUA2
 ======================
-The PJSUA2 C++ library will be built by default by PJSIP build system.
+The PJSUA2 C++ library will be built by default by PJSIP build system. Standard C++ library is required.
 
 Building Python and Java SWIG Modules
@@ -106,4 +109,5 @@
 ------------
 
+#. `SWIG <http://www.swig.org>`_
 #. ``JDK``.
 #. ``Python``, version 2.7 or above is required.